// Rob McDermott			28 July 2004
// 159.776 Visual Languages and Graphics	Assignment 2
// Interactive, animated 'IIST'
// -------------------------------------------------------------
// Mouse & keyboard events control the animation of the letters
// "IIST".
// -------------------------------------------------------------


#pragma hdrstop
//#include <condefs.h>
#include <iostream.h>
#include <windows.h>
#include <gl/Gl.h>
#include <gl/glut.h>

//---------------------------------------------------------------------------
//#pragma argsused

#define IIST_List 1 		// identifier for the list of commands that draw 'IIST'
#define PI 3.1415926535898

GLint	xD,yD,zD;	// global variables to store translation distance
GLfloat xA,yA,zA;	// rotation angles
GLuint  window, viewingWindow, textWindow;	// variables to identify the window

// function declarations
void redisplayAll(void);
void drawstr(GLvoid *font, GLfloat x, GLfloat y, char* format, ...);

void myInit(void)
{
	glClearColor(0.0,0.0,0.0,0.0);	//background - black
    glColor3f(1.0f,1.0f,1.0f);		// drawing colour - white
    glPointSize(1.0);				// dot is 1 pixel
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    //gluOrtho2D(0.0,640.0,0.0,480.0); // NB: +ve y is towards top of screen
    //glOrtho(0.0,800.0,0.0,600.0,400.0,-500.0); // NB: +ve y is towards top of screen
    glFrustum(-60.0,200.0,-30.0,100.0,100.0,2000.0); // perspective viewing: objects further away look smaller
}

void make_IIST() {

	GLuint i;
	GLfloat	cosine, sine;

	// Create a display list for the IIST logo
	glNewList(IIST_List, GL_COMPILE);

    	glBegin(GL_POLYGON);  // first 'I'
        	glVertex3i(0,0,0);
			glVertex3i(0,200,0);
	        glVertex3i(40,200,0);
			glVertex3i(40,0,0);
    	glEnd();

	    glBegin(GL_POLYGON);  // second 'I'
    	    glVertex3i(80,0,0);
			glVertex3i(80,200,0);
	        glVertex3i(120,200,0);
			glVertex3i(120,0,0);
    	glEnd();

	    glBegin(GL_POLYGON);  // 'T' stem 
    	    glVertex3i(300,0,0);
			glVertex3i(300,180,0);
			glVertex3i(340,180,0);
        	glVertex3i(340,0,0);
	    glEnd();
    	glBegin(GL_POLYGON);	// 'T' cross bar
        	glVertex3i(240,160,0);
			glVertex3i(240,200,0);
    	    glVertex3i(400,200,0);
        	glVertex3i(400,160,0);
	    glEnd();


		/*glBegin(GL_POLYGON); 		// 'S', when I figure out how...
			// Generate the points of the S
			for(i = 0; i < 100; i++) {
				cosine = cos(i * 2 * PI / 100.0);
				sine = sin(i * 2 * PI/100.0);
				glVertex2f(cosine, sine);
			}
		glEnd();
        */

	// End definition of circle
	glEndList();
}

void viewDisplay(void)
{
    //cout << "Got a display event" << endl;

	glClearColor(0.0,0.0,0.0,0.0);
	glClear(GL_COLOR_BUFFER_BIT);    // The RGB values for each pixel are stored in the color buffer,
    								// which should be cleared each time the scene is drawn
    //glColor3f(0.6f,0.6f,0.6f);	// grey
    glColor3f(0.3f,0.3f,0.9f);		// blue-grey

    glTranslatef(xD,yD,zD);		// translate the image the specified distance
    glRotatef(xA,1.0f,0.0f,0.0f);		// rotate the image the specified distance
    glRotatef(yA,0.0f,1.0f,0.0f);
    glRotatef(zA,0.0f,0.0f,1.0f);
    glTranslatef(-xD,-yD,-zD);		// translate the image the specified distance

	glCallList(IIST_List);       // Draw the predefined IIST logo
    glFlush();     				// flush the buffer
	glutSwapBuffers();	// Swap the buffers for smooth animation
}

void idler(void)
{
	xD = 0;yD = 0;zD = 0;xA = 0;yA = 0;zA = 0;	// reset all translation distances
    xA+=1;	// rotate about x axis
    redisplayAll();	//redraw the screen
}

void arrowKeys(int key, int , int y)
{
	xD = yD = zD = xA = yA = zA = 0;	// reset all translation distances
	if (key ==  GLUT_KEY_LEFT) // translate image to left;
    {
 		xD-=2;
    }
	else if (key==  GLUT_KEY_UP) // translate image up;
    {
		yD+=2;
    }
	else if (key== GLUT_KEY_RIGHT) // translate image to right;
    {
    	xD+=2;
    }
	else if (key== GLUT_KEY_DOWN) // translate image down;
    {
		yD-=2;
    }
    redisplayAll();	//redraw the screen
}


void keyboard(unsigned char key, int , int y)
{
	//cout << "Got a keyboard event: " << key << endl;
	xD = yD = zD = xA = yA = zA = 0;	// reset all translation distances

    if (key=='q') // translate image away from me;
    {
		zD-=6;
    }
    else if (key=='e') // translate image towards me;
    {
		zD+=6;
    }
    else if (key=='x') // rotate about x axis
    {
		xA+=5;
    }
    else if (key=='y') // rotate about y axis
    {
		yA+=5;
    }
    else if (key=='z') // rotate about z axis
    {
		zA+=5;
    }
    redisplayAll();	//redraw the screen
}

void redisplayAll(void)
{
    //glutSetWindow(textWindow);
    //glutPostRedisplay();
    glutSetWindow(viewingWindow);
    glutPostRedisplay();
}

void mainDisplay(void)
{
    glClearColor(0.8, 0.8, 0.8, 0.0);  // main window is grey
    glClear(GL_COLOR_BUFFER_BIT);
    glutSwapBuffers();
}

void textDisplay(void)
{
    glClear(GL_COLOR_BUFFER_BIT);
	glColor3f(0.6f,0.6f,1.0f);		// blue-grey
	drawstr(GLUT_BITMAP_HELVETICA_12,-0.5,0.3,"Arrow keys: control translation");
    drawstr(GLUT_BITMAP_HELVETICA_12,-0.5,0.0,"              q: send objects away");
    drawstr(GLUT_BITMAP_HELVETICA_12,-0.5,-0.3,"              e: bring objects closer");
	drawstr(GLUT_BITMAP_HELVETICA_12,-0.5,-0.6,"         x,y,z: rotate about the designated axis");

    glutSwapBuffers();
}

void drawstr(GLvoid *font, GLfloat x, GLfloat y, char* format, ...)
{
    va_list args;
    char buffer[255], *s;
    
    va_start(args, format);
  //  vsprintf(buffer, format, args);
    va_end(args);
    
    glRasterPos2f(x, y);
    for (s = buffer; *s; s++)
        glutBitmapCharacter(font, *s);
}

int main(int argc, char* argv[])
{
	xD = 0;
    yD = 0;
    zD = -500;
    xA = yA = zA = 0;	// initialiase translation distances

    // intialise window parameters
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB); // double buffer for animation smoothness
    glutInitWindowSize(640,480);
    glutInitWindowPosition(100,150);

    // create main window
    window = glutCreateWindow("Rob's Animated IIST");	// the main window
    glutDisplayFunc(mainDisplay);
    glutKeyboardFunc(keyboard); // register function for responding to keys
    glutSpecialFunc(arrowKeys);	// register function for responding to arrow keys

    // create sub window for the text area
	textWindow = glutCreateSubWindow(window, 20, 340, 600, 100);
    glutDisplayFunc(textDisplay);

    // create sub window for the viewing area
	viewingWindow = glutCreateSubWindow(window, 20, 20, 600, 300);
    glutDisplayFunc(viewDisplay);
    glutKeyboardFunc(keyboard);
    glutSpecialFunc(arrowKeys);

    // start things going...
    myInit();
	make_IIST();    // Call procedure to create the display list for the IIST logo

    redisplayAll();

    glutMainLoop();
}

