// Assignment 2 by yvind Smestad
// Multiple windows, FTGL text, animation, text entry
// Click and drag mouse in top windows to move text
// Type on keyboard to change the displayed text

#include <string.h>  //for strlen
#include <GL/glut.h>  /*according to the GLUT spec the most portable way is to 
						include only glut.h and not Gl.h, Glu.h (and windows.h)*/
#include "FTGLPixmapFont.h"  //to use FTGL libary

static FTFont* myFont;  //pointer to font

GLint winMain, winOne, winTwo, winThree;  //refrences to our windows
GLfloat xWin = 300, yWin = 225;  //size of coordinate systems in small windows
GLfloat xStart = 0, yStart = 0;  //initial starting point for text
static GLfloat spin = 0.0;
char defaultMessage[30] = "IIST";
char *myMessage = defaultMessage;


//initalization for winOne and winTwo
void myInit(void) {
	glClearColor(0.0, 0.0, 0.0, 0.0); //set clear window color to black
	glColor3f(1.0, 1.0, 1.0);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(-xWin/2, xWin/2, -yWin/2, yWin/2);  //use orthographic projection, 0,0 in center
}

//initalization for winThree
void myInitThree(void) {
	glClearColor(0.0, 0.0, 0.0, 0.0); //set clear window color to black
	glColor3f(1.0, 1.0, 1.0);

	myFont = new FTGLPixmapFont("verdana.ttf");  //create pixmap font
    myFont->FaceSize(24);  //set fontsize

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(-xWin/2, xWin/2, -yWin/2, yWin/2);  //use orthographic projection, 0,0 in center
}

//initalization for main window
void mainInit(void) {
	glClearColor(0.3, 0.3, 0.3, 0.0); //set clear window color to gray
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0.0, 2000, 0.0, 2000);  //use orthographic projection
}

//handler for normal key events
void processNormalKeys(unsigned char key, int x, int y) {
	//if IIST is visible remove it
	if (strcmp(defaultMessage, "IIST") ==0) {
		unsigned char empty[] = "";
		int cha = (int) strlen(defaultMessage);
		for (int i = 0; i <= cha; i++) {
			defaultMessage[i] = *empty;
		}
	}
	//add new character at end of char array
	int chars = (int) strlen(defaultMessage);
	defaultMessage[chars] = key;
	//display it in all windows
	glutSetWindow(winOne);
	glutPostRedisplay();
	glutSetWindow(winTwo);
	glutPostRedisplay();
	glutSetWindow(winThree);
	glutPostRedisplay();
	glutSetWindow(winMain);
	glutPostRedisplay();
}

//mouse handler, move text by draging the mouse
void myMouseMotion(int x, int y) {
	xStart = x - xWin/2;
	yStart = yWin - y - yWin/2;  //inverse y values

	//display in top windows
	glutSetWindow(winOne);
	glutPostRedisplay();
	glutSetWindow(winTwo);
	glutPostRedisplay();
}

//rotate text in winOne
void spinDisplay (void)
{
    spin = spin + 0.1;
    if (spin > 360.0)
	spin = spin - 360.0;
	glutSetWindow(winOne);
	glPushMatrix();	
    glRotatef (spin, 0.0, 0.0, 1.0);
    glutPostRedisplay();
}

//display function for winOne
void myDisplay(void) {
	glClear(GL_COLOR_BUFFER_BIT);  //clear screen
	glPushMatrix();	
	glTranslatef(xStart, yStart, 0);
	int len = (int) strlen(myMessage);
	for (int i = 0; i < len; i++) {
		glutStrokeCharacter(GLUT_STROKE_ROMAN, myMessage[i]);
	}
	glPopMatrix();
	glutSwapBuffers();
}
//display function for winTwo
void myDisplay2(void) {
	glClear(GL_COLOR_BUFFER_BIT);  //clear screen
	glPushMatrix();
	glTranslatef(xStart, yStart, 0);
	int len = (int) strlen(myMessage);
	for (int i = 0; i < len; i++) {
		glutStrokeCharacter(GLUT_STROKE_ROMAN, myMessage[i]);
	}
	glPopMatrix();
	glutSwapBuffers();
}
//display function for winThree
void myDisplay3(void) {
	glClear(GL_COLOR_BUFFER_BIT);
	glPushMatrix();
	glRasterPos2f(-140, 30);
	myFont->FaceSize(18);
	myFont->Render("Text is rendered with Freetype and Ftgl in this sub-window.");
	glRasterPos2f(-140, -30);
	myFont->FaceSize(24);
	myFont->Render(defaultMessage);
	glPopMatrix();
	glutSwapBuffers();
}
//display function for main window
void mainDisplay(void){
	glClear(GL_COLOR_BUFFER_BIT);
	char promptMessage[] = "Type something:";
	glPushMatrix();
	glRasterPos2f(50, 50);
	
	int len = (int) strlen(promptMessage);
	for (int i = 0; i < len; i++) {
		glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, promptMessage[i]);
	}
	if (strcmp(defaultMessage, "IIST") !=0) {
		len = (int) strlen(defaultMessage);
		for (i = 0; i < len; i++) {
			glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, defaultMessage[i]);
		}
	}
	glPopMatrix();
	glFlush();
}

//reshape main window, calling reshape and position for all sub-windows
void mainReshape(int width, int height){
	glViewport(0,0,width,height);  //this is the default reshape action
	
	glutSetWindow(winOne);
	glutPositionWindow(5, 5);
	glutReshapeWindow(width/2-8, height/2);
	
	glutSetWindow(winTwo);
	glutPositionWindow(width/2+3, 5);
	glutReshapeWindow(width/2-8, height/2);
	
	glutSetWindow(winThree);
	glutPositionWindow(5, height/2+10);
	glutReshapeWindow(width-10, height/4);	
}
//******************main*************************
void main(int argc, char** argv){
	glutInit(&argc, argv);  //initialize the toolkit
	glutInitDisplayMode(GLUT_SINGLE|GLUT_RGB);
	glutInitWindowSize(640,480);
	glutInitWindowPosition(100,150);

	winMain = glutCreateWindow("Assignment 2 by yvind Smestad");
	glutDisplayFunc(mainDisplay);
	glutKeyboardFunc(processNormalKeys);
	glutReshapeFunc(mainReshape);
	mainInit();  //must initialize each window

	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB);

	winOne = glutCreateSubWindow(winMain, 5, 5, 300, 225);
	glMatrixMode(GL_MODELVIEW);
	glEnable(GL_LINE_SMOOTH);  //make this window smooth
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glLineWidth(3.0);
	glutDisplayFunc(myDisplay);
	glutKeyboardFunc(processNormalKeys);
	glutMotionFunc(myMouseMotion);
	myInit();  //must initialize each window

	winTwo = glutCreateSubWindow(winMain, 310, 5, 300, 225);
	glutDisplayFunc(myDisplay2);
	glutKeyboardFunc(processNormalKeys);
	glutMotionFunc(myMouseMotion);
	myInit();  //must initialize each window

	winThree = glutCreateSubWindow(winMain, 5, 235, 605, 125);
	glutDisplayFunc(myDisplay3);
	glutKeyboardFunc(processNormalKeys);
	myInitThree();  //must initialize each window

	glutIdleFunc (spinDisplay);
	glutMainLoop();
}